var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component } from '@angular/core';
import { Services } from '../services';
import { TraversingComponent } from '../traversing';
var Breadcrumbs = (function (_super) {
    __extends(Breadcrumbs, _super);
    function Breadcrumbs(services) {
        var _this = _super.call(this, services) || this;
        _this.services = services;
        _this.links = [];
        return _this;
    }
    Breadcrumbs.prototype.onTraverse = function (target) {
        var _this = this;
        var components = target.context['@components']; // breadcrumbs we got with expansion;
        if (components && components.breadcrumbs.items) {
            this.links = components.breadcrumbs.items;
        }
        else {
            if (target.contextPath) {
                this.services.resource.breadcrumbs(target.contextPath)
                    .subscribe(function (links) {
                    _this.links = links;
                });
            }
        }
    };
    Breadcrumbs.decorators = [
        { type: Component, args: [{
                    selector: 'plone-breadcrumbs',
                    template: "\n    <ol class=\"breadcrumb\">\n      <li><a traverseTo=\"/\">Home</a></li>\n      <li *ngFor=\"let link of links; let last = last\" [ngClass]=\"{active: last}\">\n        <a *ngIf=\"!last\" [traverseTo]=\"link.url\">{{ link.title }}</a>\n        <span *ngIf=\"last\">{{ link.title }}</span>\n      </li>\n    </ol>"
                },] },
    ];
    /** @nocollapse */
    Breadcrumbs.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return Breadcrumbs;
}(TraversingComponent));
export { Breadcrumbs };
