var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Services } from '../services';
import { TraversingComponent } from '../traversing';
var Comment = (function () {
    function Comment() {
    }
    Comment.prototype.formatText = function (text) {
        if (!text) {
            return '';
        }
        if (text['mime-type'] === 'text/plain') {
            return text.data.replace(/\n/g, '<br>');
        }
        else {
            return text.data;
        }
    };
    Comment.decorators = [
        { type: Component, args: [{
                    selector: 'plone-comment',
                    template: "<p>\n    <span class=\"comment-author\">{{ comment.author_name }}</span>\n    <span class=\"comment-date\">{{ comment.creation_date | date }}</span>\n  </p>\n  <div class=\"comment-body\" [innerHTML]=\"formatText(comment.text)\"></div>"
                },] },
    ];
    /** @nocollapse */
    Comment.ctorParameters = function () { return []; };
    Comment.propDecorators = {
        "comment": [{ type: Input },],
    };
    return Comment;
}());
export { Comment };
var CommentAdd = (function () {
    function CommentAdd(services) {
        this.services = services;
        this.onCreate = new EventEmitter();
    }
    CommentAdd.prototype.add = function (form) {
        var _this = this;
        this.services.comments.add(this.path, form.value).subscribe(function (res) {
            _this.onCreate.next(true);
            form.resetForm();
        }, function (err) {
            _this.error = err.message;
        });
    };
    CommentAdd.decorators = [
        { type: Component, args: [{
                    selector: 'plone-comment-add',
                    template: "\n    <form #f=\"ngForm\" (submit)=\"add(f)\">\n      <div *ngIf=\"error\">{{ error }}</div>\n      <div>\n        <label>E-mail <input type=\"email\" name=\"author_email\" ngModel/></label>\n      </div>\n      <div>\n        <label>Comment <textarea name=\"text\" ngModel></textarea></label>\n      </div>\n      <input type=\"submit\" value=\"Comment\"/>\n    </form>"
                },] },
    ];
    /** @nocollapse */
    CommentAdd.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    CommentAdd.propDecorators = {
        "path": [{ type: Input },],
        "onCreate": [{ type: Output },],
    };
    return CommentAdd;
}());
export { CommentAdd };
var Comments = (function (_super) {
    __extends(Comments, _super);
    function Comments(services) {
        var _this = _super.call(this, services) || this;
        _this.services = services;
        _this.comments = [];
        return _this;
    }
    Comments.prototype.onTraverse = function (target) {
        if (target.contextPath) {
            this.contextPath = target.contextPath;
            this.allowDiscussion = target.context.allow_discussion || false;
            this.loadComments();
        }
    };
    Comments.prototype.loadComments = function () {
        var _this = this;
        this.services.comments.get(this.contextPath).subscribe(function (res) {
            _this.comments = res.items;
        });
    };
    Comments.decorators = [
        { type: Component, args: [{
                    selector: 'plone-comments',
                    template: "\n    <div class=\"comments\">\n      <plone-comment-add\n        *ngIf=\"allowDiscussion\"\n        [path]=\"contextPath\"\n        (onCreate)=\"loadComments()\"></plone-comment-add>\n      <div class=\"comment\" *ngFor=\"let comment of comments\">\n        <plone-comment [comment]=\"comment\"></plone-comment>\n      </div>\n    </div>"
                },] },
    ];
    /** @nocollapse */
    Comments.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return Comments;
}(TraversingComponent));
export { Comments };
