var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component } from '@angular/core';
import { Services } from '../services';
import { TraversingComponent } from '../traversing';
import { Observable } from 'rxjs/Observable';
var GlobalNavigation = (function (_super) {
    __extends(GlobalNavigation, _super);
    function GlobalNavigation(services) {
        var _this = _super.call(this, services) || this;
        _this.services = services;
        _this.links = [];
        return _this;
    }
    GlobalNavigation.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        var component = this;
        component.refreshNavigation = Observable.of(null)
            .merge(component.services.navigation.refreshNavigation)
            .mergeMap(function () { return component.services.resource.navigation(); })
            .subscribe(function (links) {
            _this.setLinks(links);
        });
    };
    GlobalNavigation.prototype.setLinks = function (links) {
        this.links = links;
        this.setActiveLinks(this.contextPath);
    };
    GlobalNavigation.prototype.onTraverse = function (target) {
        // contextPath = '' for the root of the site - always set the contextPath
        this.contextPath = target.contextPath;
        this.setActiveLinks(this.contextPath);
    };
    GlobalNavigation.prototype.ngOnDestroy = function () {
        if (this.refreshNavigation.unsubscribe) {
            this.refreshNavigation.unsubscribe();
        }
    };
    GlobalNavigation.prototype.setActiveLinks = function (contextPath) {
        this.links.map(function (link) {
            if (!contextPath || contextPath === '/') {
                link.active = (!link.path || link.path === '/');
            }
            else {
                var targetList = contextPath.split('/');
                var linkList = link.path.split('/');
                var isSubpath = true; // you could just use link.active
                for (var _i = 0, _a = linkList.map(function (item, index) { return ({ item: item, index: index }); }); _i < _a.length; _i++) {
                    var _b = _a[_i], item = _b.item, index = _b.index;
                    if (item !== targetList[index]) {
                        isSubpath = false;
                    }
                }
                link.active = isSubpath;
            }
        });
    };
    GlobalNavigation.decorators = [
        { type: Component, args: [{
                    selector: 'plone-global-navigation',
                    template: "\n    <ul>\n      <li *ngFor=\"let link of links\" [ngClass]=\"{'active': link.active}\">\n        <a [traverseTo]=\"link.path\">{{ link.title }}</a>\n      </li>\n    </ul>"
                },] },
    ];
    /** @nocollapse */
    GlobalNavigation.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return GlobalNavigation;
}(TraversingComponent));
export { GlobalNavigation };
