var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Input } from '@angular/core';
import { Services } from '../services';
import { TraversingComponent } from '../traversing';
import { Observable } from 'rxjs/Observable';
var Navigation = (function (_super) {
    __extends(Navigation, _super);
    function Navigation(services) {
        var _this = _super.call(this, services) || this;
        _this.services = services;
        _this.root = '/';
        _this.depth = -1;
        return _this;
    }
    Navigation.prototype.onTraverse = function (target) {
        var component = this;
        var navigation = component.services.navigation;
        component.removeSubscriptions();
        this.refreshNavigation = Observable.of(null)
            .merge(navigation.refreshNavigation)
            .mergeMap(function () { return navigation.getNavigationFor(target.context['@id'], component.root, component.depth); })
            .subscribe(function (tree) {
            component.links = tree.children;
        });
    };
    Navigation.prototype.ngOnDestroy = function () {
        this.removeSubscriptions();
    };
    Navigation.prototype.removeSubscriptions = function () {
        if (this.refreshNavigation) {
            this.refreshNavigation.unsubscribe();
        }
    };
    Navigation.decorators = [
        { type: Component, args: [{
                    selector: 'plone-navigation',
                    template: "\n    <plone-navigation-level\n      [links]=\"links\"></plone-navigation-level>"
                },] },
    ];
    /** @nocollapse */
    Navigation.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    Navigation.propDecorators = {
        "root": [{ type: Input },],
        "depth": [{ type: Input },],
    };
    return Navigation;
}(TraversingComponent));
export { Navigation };
