import { EventEmitter } from '@angular/core';
import { Services } from '../services';
import { TraversingComponent } from '../traversing';
import { Target } from 'angular-traversal';
import { WorkflowHistoryItem, WorkflowInformation, WorkflowTransitionItem } from '../interfaces';
export declare class Workflow extends TraversingComponent {
    services: Services;
    showHistory: boolean;
    haveCommentInput: boolean;
    contextPath: string;
    commentText: string;
    workflowInformation: WorkflowInformation | null;
    workflowStateChanged: EventEmitter<WorkflowHistoryItem>;
    constructor(services: Services);
    onTraverse(target: Target): void;
    protected loadWorkflowInformation(): void;
    processTransition(event: Event, item: WorkflowTransitionItem): void;
    currentState(): string | null;
    displayTime(datestr: string): string;
}
