import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import 'rxjs/add/operator/catch';
import { AuthenticationService } from './authentication.service';
import { ConfigurationService } from './configuration.service';
import { LoadingStatus } from '../interfaces';
import { LoadingService } from './loading.service';
export declare class APIService {
    protected authentication: AuthenticationService;
    protected config: ConfigurationService;
    protected http: HttpClient;
    status: BehaviorSubject<LoadingStatus>;
    backendAvailable: BehaviorSubject<boolean>;
    constructor(authentication: AuthenticationService, config: ConfigurationService, http: HttpClient, loading: LoadingService);
    get(path: string): Observable<any>;
    post(path: string, data: Object): Observable<any>;
    patch(path: string, data: Object): Observable<any>;
    delete(path: string): Observable<any>;
    download(path: string): Observable<Blob | {}>;
    getFullPath(path: string): string;
    private wrapRequest<T>(request);
    protected setBackendAvailability(availability: boolean): void;
}
