import { HttpClient, HttpErrorResponse, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { ConfigurationService } from './configuration.service';
import { AuthenticatedStatus, Error, PasswordResetInfo } from '../interfaces';
export interface UserInfoTokenParts {
    username?: string;
    sub?: string;
    exp?: number;
    fullname?: string;
}
export declare class AuthenticationService {
    protected config: ConfigurationService;
    protected http: HttpClient;
    protected platformId: Object;
    isAuthenticated: BehaviorSubject<AuthenticatedStatus>;
    constructor(config: ConfigurationService, http: HttpClient, platformId: Object);
    getUsername(): string | null;
    protected getUserTokenInfo(): UserInfoTokenParts | null;
    login(login: string, password: string): Observable<any>;
    logout(): void;
    requestPasswordReset(login: string): Observable<any>;
    passwordReset(resetInfo: PasswordResetInfo): Observable<any>;
    getHeaders(): HttpHeaders;
    protected error(errorResponse: HttpErrorResponse): Observable<Error>;
}
export declare function getError(errorResponse: HttpErrorResponse): Error;
