import { EventEmitter } from '@angular/core';
import 'rxjs/add/observable/of';
import { Observable } from 'rxjs/Observable';
import { APIService } from './api.service';
import { AuthenticationService } from './authentication.service';
import { ConfigurationService } from './configuration.service';
export declare class CacheService {
    protected auth: AuthenticationService;
    protected api: APIService;
    protected config: ConfigurationService;
    private cache;
    private refreshDelay;
    private maxSize;
    revoke: EventEmitter<string | null>;
    hits: {
        [key: string]: number;
    };
    constructor(auth: AuthenticationService, api: APIService, config: ConfigurationService);
    get<T>(url: string): Observable<T>;
    revoking<T>(observable: Observable<T>, revoked?: string | null): Observable<T>;
}
