import { Injectable } from '@angular/core';
import { APIService } from './api.service';
import { CacheService } from './cache.service';
var CommentsService = (function () {
    function CommentsService(api, cache) {
        this.api = api;
        this.cache = cache;
    }
    CommentsService.prototype.add = function (path, data) {
        var url = path + '/@comments';
        return this.cache.revoking(this.api.post(url, data), url);
    };
    CommentsService.prototype.delete = function (path) {
        return this.cache.revoking(this.api.delete(path), path);
    };
    CommentsService.prototype.get = function (path) {
        return this.cache.get(path + '/@comments');
    };
    CommentsService.prototype.update = function (path, data) {
        return this.cache.revoking(this.api.patch(path, data), path);
    };
    CommentsService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    CommentsService.ctorParameters = function () { return [
        { type: APIService, },
        { type: CacheService, },
    ]; };
    return CommentsService;
}());
export { CommentsService };
