import { Inject, Injectable } from '@angular/core';
var ConfigurationService = (function () {
    function ConfigurationService(config) {
        this.config = config;
    }
    ConfigurationService.prototype.get = function (key, defaultValue) {
        if (defaultValue !== undefined && !(this.config.hasOwnProperty(key))) {
            return defaultValue;
        }
        else {
            return this.config[key];
        }
    };
    ConfigurationService.prototype.urlToPath = function (url) {
        var base = this.get('BACKEND_URL');
        return url.split(base)[1] || '/';
    };
    ConfigurationService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ConfigurationService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: ['CONFIGURATION',] },] },
    ]; };
    return ConfigurationService;
}());
export { ConfigurationService };
