import { EventEmitter } from '@angular/core';
import 'rxjs/add/observable/of';
import { Observable } from 'rxjs/Observable';
import { ConfigurationService } from './configuration.service';
import { NavTree } from '../interfaces';
import { ResourceService } from './resource.service';
import { AuthenticationService } from './authentication.service';
export declare class NavigationService {
    protected resource: ResourceService;
    protected config: ConfigurationService;
    refreshNavigation: EventEmitter<null>;
    constructor(auth: AuthenticationService, resource: ResourceService, config: ConfigurationService);
    getNavigationFor(currentPath: string, root: string | number, depth: number): Observable<NavTree>;
    private getOrderedChildren(children);
    private markActive(currentPath, tree);
    private getRoot(currentPath, root);
}
