import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { NamedFileUpload, NavLink, SearchOptions, SearchResults, WorkflowHistoryItem, WorkflowInformation, WorkflowTransitionOptions } from '../interfaces';
import { Vocabulary } from '../vocabularies';
import { APIService } from './api.service';
import { CacheService } from './cache.service';
import { ConfigurationService } from './configuration.service';
export declare class ResourceService {
    protected api: APIService;
    protected cache: CacheService;
    protected configuration: ConfigurationService;
    defaultExpand: any;
    resourceModified: EventEmitter<{
        id: string;
        context: any;
    } | null>;
    static getSearchQueryString(query: {
        [key: string]: any;
    }, options?: SearchOptions): string;
    static lightFileRead(file: File): Observable<NamedFileUpload>;
    constructor(api: APIService, cache: CacheService, configuration: ConfigurationService);
    copy(sourcePath: string, targetPath: string): Observable<any>;
    create(path: string, model: any): Observable<any>;
    delete(path: string): Observable<any>;
    find(query: {
        [key: string]: any;
    }, path?: string, options?: SearchOptions): Observable<SearchResults>;
    get(path: string, expand?: string[]): Observable<{}>;
    move(sourcePath: string, targetPath: string): Observable<any>;
    transition<S extends string = string, T extends string = string>(contextPath: string, transition: T, options?: WorkflowTransitionOptions): Observable<WorkflowHistoryItem<S, T>>;
    workflow<S extends string = string, T extends string = string>(contextPath: string): Observable<WorkflowInformation<S, T>>;
    update(path: string, model: any): Observable<any>;
    navigation(): Observable<NavLink[]>;
    breadcrumbs(path: string): Observable<NavLink[]>;
    type(typeId: string): Observable<any>;
    vocabulary(vocabularyId: string): Observable<Vocabulary<string | number>>;
    emittingModified<T>(observable: Observable<T>, path: string): Observable<T>;
    private linkFromItem(item);
}
