import { Marker, Normalizer, Resolver, Traverser } from 'angular-traversal';
import { Observable } from 'rxjs/Observable';
import { APIService } from './services/api.service';
import { ConfigurationService } from './services/configuration.service';
import { ResourceService } from './services/resource.service';
export declare class InterfaceMarker extends Marker {
    mark(context: any): string[];
}
export declare class TypeMarker extends Marker {
    mark(context: any): string;
}
export declare class RESTAPIResolver extends Resolver {
    private api;
    private resource;
    constructor(api: APIService, resource: ResourceService);
    resolve(path: string, view: string, queryString: string): Observable<any>;
}
export declare class PloneViews {
    private traverser;
    constructor(traverser: Traverser);
    initialize(): void;
}
export declare class FullPathNormalizer extends Normalizer {
    private config;
    constructor(config: ConfigurationService);
    normalize(path: string): string;
}
