var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable } from '@angular/core';
import { Marker, Normalizer, Resolver, Traverser } from 'angular-traversal';
import { APIService } from './services/api.service';
import { ConfigurationService } from './services/configuration.service';
import { ResourceService } from './services/resource.service';
import { AddView } from './views/add';
import { EditView } from './views/edit';
import { LoginView } from './views/login';
import { PasswordResetView } from './views/password-reset';
import { RequestPasswordResetView } from './views/request-password-reset';
import { SearchView } from './views/search';
import { SitemapView } from './views/sitemap';
import { ViewView } from './views/view';
var InterfaceMarker = (function (_super) {
    __extends(InterfaceMarker, _super);
    function InterfaceMarker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InterfaceMarker.prototype.mark = function (context) {
        return context.interfaces;
    };
    InterfaceMarker.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    InterfaceMarker.ctorParameters = function () { return []; };
    return InterfaceMarker;
}(Marker));
export { InterfaceMarker };
var TypeMarker = (function (_super) {
    __extends(TypeMarker, _super);
    function TypeMarker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TypeMarker.prototype.mark = function (context) {
        return context['@type'];
    };
    TypeMarker.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    TypeMarker.ctorParameters = function () { return []; };
    return TypeMarker;
}(Marker));
export { TypeMarker };
var RESTAPIResolver = (function (_super) {
    __extends(RESTAPIResolver, _super);
    function RESTAPIResolver(api, resource) {
        var _this = _super.call(this) || this;
        _this.api = api;
        _this.resource = resource;
        return _this;
    }
    RESTAPIResolver.prototype.resolve = function (path, view, queryString) {
        if (view === 'search') {
            path = !path.endsWith('/') ? path + '/' : path;
            return this.api.get(path + '@search?' + queryString);
        }
        else {
            return this.resource.get(path);
        }
    };
    RESTAPIResolver.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    RESTAPIResolver.ctorParameters = function () { return [
        { type: APIService, },
        { type: ResourceService, },
    ]; };
    return RESTAPIResolver;
}(Resolver));
export { RESTAPIResolver };
var PloneViews = (function () {
    function PloneViews(traverser) {
        this.traverser = traverser;
    }
    PloneViews.prototype.initialize = function () {
        this.traverser.addView('add', '*', AddView);
        this.traverser.addView('edit', '*', EditView);
        this.traverser.addView('login', '*', LoginView);
        this.traverser.addView('request-password-reset', '*', RequestPasswordResetView);
        this.traverser.addView('password-reset', '*', PasswordResetView);
        this.traverser.addView('search', '*', SearchView);
        this.traverser.addView('sitemap', '*', SitemapView);
        this.traverser.addView('view', '*', ViewView);
    };
    PloneViews.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    PloneViews.ctorParameters = function () { return [
        { type: Traverser, },
    ]; };
    return PloneViews;
}());
export { PloneViews };
var FullPathNormalizer = (function (_super) {
    __extends(FullPathNormalizer, _super);
    function FullPathNormalizer(config) {
        var _this = _super.call(this) || this;
        _this.config = config;
        return _this;
    }
    FullPathNormalizer.prototype.normalize = function (path) {
        if (path == null) {
            return path;
        }
        var base = this.config.get('BACKEND_URL');
        if (path.startsWith(base)) {
            return path.split(base)[1];
        }
        else {
            return path;
        }
    };
    FullPathNormalizer.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    FullPathNormalizer.ctorParameters = function () { return [
        { type: ConfigurationService, },
    ]; };
    return FullPathNormalizer;
}(Normalizer));
export { FullPathNormalizer };
