var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, PLATFORM_ID } from '@angular/core';
import { isPlatformBrowser } from '@angular/common';
import { URLSearchParams } from '@angular/http';
import 'rxjs/add/operator/takeUntil';
import { TraversingComponent } from '../traversing';
import { Services } from '../services';
import { takeUntil } from 'rxjs/operators';
var AddView = (function (_super) {
    __extends(AddView, _super);
    function AddView(services, platformId) {
        var _this = _super.call(this, services) || this;
        _this.services = services;
        _this.platformId = platformId;
        // TODO: addable types should be provided by the backend
        _this.types = [
            'Document',
            'Folder',
            'News Item',
            'Event',
            'File',
            'Image',
        ];
        return _this;
    }
    AddView.prototype.ngOnInit = function () {
        var _this = this;
        this.services.traverser.target
            .pipe(takeUntil(this.ngUnsubscribe))
            .subscribe(function (target) {
            _this.path = target.contextPath;
        });
        if (isPlatformBrowser(this.platformId)) {
            var params = new URLSearchParams(window.location.search.slice(1));
            var param = params.paramsMap.get('type');
            if (param && param.length > 0) {
                this.type = param[0];
            }
        }
    };
    AddView.prototype.onSave = function (model) {
        var _this = this;
        model['@type'] = this.type;
        this.services.resource.create(this.path, model).subscribe(function (res) {
            _this.services.traverser.traverse(res['@id']);
        });
    };
    AddView.prototype.onCancel = function () {
        this.services.traverser.traverse(this.path);
    };
    AddView.decorators = [
        { type: Component, args: [{
                    selector: 'plone-add',
                    template: "<ng-container *ngIf=\"!type\">Add a new:<ul >\n  <li *ngFor=\"let type of types\">\n    <a [traverseTo]=\"'@@add?type=' + type\">{{ type }}</a>\n  </li>\n</ul></ng-container>\n<form *ngIf=\"type\" #f=\"ngForm\" (submit)=\"onSave(f.value)\">\n  <p><label>Title : <input type=\"text\" name=\"title\" ngModel /></label></p>\n  <p><label>Description : <textarea name=\"description\" ngModel></textarea></label></p>\n  <button (click)=\"onSave(f.value)\">Save</button><button (click)=\"onCancel()\">Cancel</button>\n</form>"
                },] },
    ];
    /** @nocollapse */
    AddView.ctorParameters = function () { return [
        { type: Services, },
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] },] },
    ]; };
    return AddView;
}(TraversingComponent));
export { AddView };
