var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component } from '@angular/core';
import { TraversingComponent } from '../traversing';
import { Services } from '../services';
var EditView = (function (_super) {
    __extends(EditView, _super);
    function EditView(services) {
        var _this = _super.call(this, services) || this;
        _this.model = {};
        return _this;
    }
    EditView.prototype.onTraverse = function (target) {
        this.path = target.contextPath;
        this.model = target.context;
    };
    EditView.prototype.onSave = function (data) {
        var _this = this;
        this.services.resource.update(this.path, data).subscribe(function () {
            _this.services.traverser.traverse(_this.path);
        });
    };
    EditView.prototype.onCancel = function () {
        this.services.traverser.traverse(this.path);
    };
    EditView.prototype.loginOn401 = function (err) {
        if (err.status === 401) {
            this.services.authentication.logout();
            this.services.traverser.traverse(this.services.traverser.target.getValue().contextPath + '/@@login');
        }
        else {
            this.onError(err);
        }
    };
    EditView.prototype.onError = function (err) {
        console.error(err);
    };
    EditView.decorators = [
        { type: Component, args: [{
                    selector: 'plone-edit',
                    template: "<form #f=\"ngForm\" (submit)=\"onSave(f.value)\">\n  <p><label>Title : <input type=\"text\" name=\"title\" [ngModel]=\"model.title\" /></label></p>\n  <p><label>Description : <textarea name=\"description\" [ngModel]=\"model.description\"></textarea></label></p>\n  <button (click)=\"onSave(f.value)\">Save</button><button (click)=\"onCancel()\">Cancel</button>\n</form>"
                },] },
    ];
    /** @nocollapse */
    EditView.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return EditView;
}(TraversingComponent));
export { EditView };
