import { Component } from '@angular/core';
import { Services } from '../services';
var LoginView = (function () {
    function LoginView(services) {
        this.services = services;
        this.error = '';
    }
    LoginView.prototype.ngOnInit = function () {
        var _this = this;
        this.services.authentication.isAuthenticated
            .subscribe(function (auth) {
            _this.isLogged = auth.state;
        });
    };
    LoginView.prototype.onSubmit = function (data) {
        var _this = this;
        this.services.authentication.login(data.login, data.password)
            .subscribe(function () {
            _this.services.traverser.traverse(_this.services.traverser.target.getValue().contextPath);
            _this.error = '';
        }, function (error) {
            _this.error = error.message;
        });
    };
    LoginView.decorators = [
        { type: Component, args: [{
                    selector: 'plone-login',
                    template: "<h2>Login</h2>\n  <form #form=\"ngForm\" (ngSubmit)=\"onSubmit(form.value)\">\n    <p class=\"error\" *ngIf=\"error\">{{ error }}</p>\n    <p><label>Login <input type=\"text\" name=\"login\" ngModel/></label></p>\n    <p><label>Password <input type=\"password\" name=\"password\" ngModel/></label></p>\n    <input type=\"submit\" value=\"Login\"/>\n  </form>"
                },] },
    ];
    /** @nocollapse */
    LoginView.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return LoginView;
}());
export { LoginView };
