import { Component } from '@angular/core';
import { Services } from '../services';
var RequestPasswordResetView = (function () {
    function RequestPasswordResetView(services) {
        this.services = services;
        this.error = '';
    }
    RequestPasswordResetView.prototype.ngOnInit = function () {
    };
    RequestPasswordResetView.prototype.onSubmit = function (formInfo) {
        var _this = this;
        this.services.authentication.requestPasswordReset(formInfo.login)
            .subscribe(function () {
            _this.error = '';
            _this.services.traverser.traverse('/@@login');
        }, function (error) {
            if (error.response && error.response.status === 404) {
                _this.error = 'This user does not exist.';
            }
            else if (error.response && error.response.status < 500) {
                _this.error = error.message;
            }
            else {
                _this.error = 'Password reset failed.';
                console.error(error);
            }
        });
    };
    RequestPasswordResetView.decorators = [
        { type: Component, args: [{
                    selector: 'plone-request-password-reset',
                    template: "<h2>Request password reset</h2>\n  <form #form=\"ngForm\" (ngSubmit)=\"onSubmit(form.value)\">\n    <p class=\"error\" *ngIf=\"error\">{{ error }}</p>\n    <p><label>Login <input type=\"text\" name=\"login\" ngModel/></label></p>\n    <input type=\"submit\" value=\"Send\"/>\n  </form>"
                },] },
    ];
    /** @nocollapse */
    RequestPasswordResetView.ctorParameters = function () { return [
        { type: Services, },
    ]; };
    return RequestPasswordResetView;
}());
export { RequestPasswordResetView };
