var Vocabulary = (function () {
    function Vocabulary(terms) {
        this._byToken = {};
        this._terms = terms;
        for (var _i = 0, terms_1 = terms; _i < terms_1.length; _i++) {
            var term = terms_1[_i];
            this._byToken[term.token] = term;
        }
    }
    Vocabulary.prototype.terms = function () {
        return this._terms;
    };
    Vocabulary.prototype.byToken = function (token) {
        var term = this._byToken[token];
        if (term === undefined) {
            return {
                '@id': '',
                token: token,
                title: (typeof token === 'number' ? token.toString() : token)
            };
        }
        else {
            return term;
        }
    };
    Vocabulary.prototype[Symbol.iterator] = function () {
        var counter = 0;
        var terms = this._terms;
        return {
            next: function () {
                if (counter < terms.length) {
                    return { done: false, value: terms[counter++] };
                }
                else {
                    return { done: true, value: undefined };
                }
            }
        };
    };
    return Vocabulary;
}());
export { Vocabulary };
